Page MenuHomePhabricator

[Feedback] Not supporting adding multiple signatures in a comment
Closed, ResolvedPublic

Description

Right now, we can add multiple signatures in a single reply. Should we support this? It seems like an unusual/impractical use case to me.

Even if for whatever reason we do support this, we should probably consider adding only one Reply button after both signatures. Right now, it's showing two Reply links for both signatures and with no space in between which also doesn't look pretty.

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptDec 12 2019, 11:23 PM

Even if for whatever reason we do support this, we should probably consider adding only one Reply button after both signatures. Right now, it's showing two Reply links for both signatures and with no space in between which also doesn't look pretty.

There's a use case for having two signatures on one "line": if you corrected/expanded your comment after writing it. Some examples I found quickly:

Currently, the parser in DiscussionTools has no specia logic to handle this, and will treat these as two separate comments, so that's why there are two separate "Reply" buttons. We should probably think about this.

Right now, we can add multiple signatures in a single reply. Should we support this? It seems like an unusual/impractical use case to me.

It's not really useful right now, since we only support adding new replies, but I think there's also no reason to forbid it. If/when we implement editing comments, I think users will expect to be able to add a second signature like this, to indicate when the comment was edited.

Even if for whatever reason we do support this, we should probably consider adding only one Reply button after both signatures. Right now, it's showing two Reply links for both signatures and with no space in between which also doesn't look pretty.

There's a use case for having two signatures on one "line": if you corrected/expanded your comment after writing it. Some examples I found quickly:

Currently, the parser in DiscussionTools has no specia logic to handle this, and will treat these as two separate comments, so that's why there are two separate "Reply" buttons. We should probably think about this.

Right now, we can add multiple signatures in a single reply. Should we support this? It seems like an unusual/impractical use case to me.

It's not really useful right now, since we only support adding new replies, but I think there's also no reason to forbid it. If/when we implement editing comments, I think users will expect to be able to add a second signature like this, to indicate when the comment was edited.

Thanks @matmarex for explaining it. I guess in that case, we can keep it as is right now, until we implement editing comments.

Alsee added a subscriber: Alsee.Dec 15 2019, 4:39 AM

There are various use cases for multiple signatures, as well as for disabling the final auto-signature. One example:

{{RFC}}
This summary of the RFC topic is short and signed, because everything up to the signature gets copied onto the list of open RFCs. ~~~~

Long Long Long explanation of the problem.

Long Long Long explanation of the proposed solution. The RFC itself is signed. ~~~~

==Responses==
* '''Support''' this proposal for reasons and reasons. My vote must be signed. (The automatic signature appears here.)

Note that a common variation would place a vote in a ==Support== section with a manual signature, followed by empty sections for ==Oppose== and ==Discussion==. The current design would incorrectly place a signature in the last section. The user would want to remove/disable the misplaced automatic signature.

Regarding the RfC example, if there is any sort of markup change (e.g. T230683), it's possible that comments could become more clearly delineated (both on the rendered page and in the wikitext source). In the case where the end of the comment is marked only by the signature, the code example would continue to work; but in the case where the end of the comment is marked by something else, it's very possible that the software would inadvertently include the section headers inside the comment (and possibly other things; e.g., if the user chooses not to sign the long explanation, they might not want that inside their comment either).

Regardless, it wouldn't currently be possible to post the example anyway, because the software in its current state can only generate replies, whereas this would be posted at the start of a page or section (see T239978).

Even if for whatever reason we do support this, we should probably consider adding only one Reply button after both signatures. Right now, it's showing two Reply links for both signatures and with no space in between which also doesn't look pretty.

There's a use case for having two signatures on one "line": if you corrected/expanded your comment after writing it. (…)

Currently, the parser in DiscussionTools has no specia logic to handle this, and will treat these as two separate comments, so that's why there are two separate "Reply" buttons. We should probably think about this.

I've thought about this some more and there is definitely a good argument for only having a "Reply" button for only one comment per line (per paragraph etc.). This came up again while I was writing some tests for the code which inserts new replies.

For a comment like the ones I showed earlier, which would generate two "Reply" buttons right now, it seems that the reply should be inserted in exactly the same way no matter which button is clicked. (We definitely don't want to "split" that comment with a reply if you clicked the "Reply" in the middle of it.) So we should just have one button.

Change 566395 had a related patch set uploaded (by Bartosz Dziewoński; owner: Bartosz Dziewoński):
[mediawiki/extensions/DiscussionTools@master] parser: Merge multiple comments on one line

https://gerrit.wikimedia.org/r/566395

matmarex claimed this task.Jan 22 2020, 2:09 AM
matmarex edited projects, added VisualEditor (Current work); removed VisualEditor.
matmarex moved this task from Incoming to Code review on the VisualEditor (Current work) board.
Alsee added a comment.Jan 24 2020, 6:19 PM

I agree with matmarex, a line/paragraph should be treated as an indivisible block.

It's not unusual to add unsigned text added after a comment, such as tagging a sockpuppet/SPA/canvassed user. That should not be split from the line. Multiple signatures on a line would generally be a modified or appended comment which should not be split. I would expect to use the normal edit button to do anything like line splitting.

Change 566395 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] parser: Merge multiple comments on one line

https://gerrit.wikimedia.org/r/566395

So to summarize:

  • When you're posting a reply, we allow you to type in a signature (or multiple) manually with ~~~~, in which case we don't add another one at the end of the comment. This is a bit silly to do, but there is not really any reason to try to disallow it. A more practical use case is adding a second signature to a comment in the upcoming comment-editing workflow (e.g. if you're making a significant correction to your previous comment and want to note when it was corrected).
  • When the page already contains a comment with multiple signatures (within a single paragraph or list item), there will be only one "Reply" button added, at the end of the line.

When the page already contains a comment with multiple signatures (within a single paragraph or list item), there will be only one "Reply" button added, at the end of the line.

Agreed. Paragraphs should be treated as indivisible in every case I can think of, and if I really do want to split a paragraph I would expect to use the full edit button.

When you're posting a reply, we allow you to type in a signature (or multiple) manually with ~~~~, in which case we don't add another one at the end of the comment.

I expect this behavior will be extremely unexpected and confusing, resulting in faulty posts.

The fundamental problem here is that the product design deliberately denies the user any direct control over the auto-indentation and auto-signature. You're guessing what the user wants, making that guess mandatory, and in this particular case that guess that is probably wrong and unexpected.

I don't think it's going to be confusing. We'll find out for sure after we start beta testing.

JTannerWMF moved this task from Inbox to High Priority on the Editing QA board.Feb 5 2020, 2:40 AM
JTannerWMF edited projects, added OWC2020 (OWC2020 Replying 1.0); removed OWC2020.

So to summarize:

  • When you're posting a reply, we allow you to type in a signature (or multiple) manually with ~~~~, in which case we don't add another one at the end of the comment. This is a bit silly to do, but there is not really any reason to try to disallow it. A more practical use case is adding a second signature to a comment in the upcoming comment-editing workflow (e.g. if you're making a significant correction to your previous comment and want to note when it was corrected).
  • When the page already contains a comment with multiple signatures (within a single paragraph or list item), there will be only one "Reply" button added, at the end of the line.

Great! Verified these two workflow fixes.

Ryasmeen edited projects, added Verified; removed Editing QA.Feb 6 2020, 8:42 PM
ppelberg closed this task as Resolved.Feb 11 2020, 1:37 AM
Restricted Application added a project: User-Ryasmeen. · View Herald TranscriptFeb 11 2020, 1:37 AM